#include <App.hpp>

RedactedFrameworkAppTemplate::RedactedFrameworkAppTemplate(const std::string &title, int width, int height): OpenGLWindow(title, width, height, GL_VER_MAJOR, GL_VER_MINOR) {

}

bool RedactedFrameworkAppTemplate::Load() {
    using namespace JUI::UDimLiterals;

    // FilteringMode::Nearest ensures crisp pixels with no "blending".
    logo = new JGL::Texture("assets/redacted.png", FilteringMode::NEAREST);

    scene = new JUI::Scene();

    auto* text_box = new JUI::TextRect(scene);
    text_box->Size({200_px, 50_px});
    text_box->SetContent("Redactd Software");

    return true;
}

bool RedactedFrameworkAppTemplate::Open() {
    if (!OpenGLWindow::Open()) return false;

    auto size = GetSize(); // ReWindow returns an IPair, and we convert it to a J3ML vector to pass to the graphics abstraction.
    auto vec_size = Vector2i(size.x, size.y);
    if (!JGL::Init(vec_size, 0.f, 1.f))
        return false;
    JGL::Update(vec_size);

    glClearColor(0.f, 0.f, 0.f, 0.f);

    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LESS);
    glDepthMask(GL_TRUE);
    // TODO: Delete when we update to the next release of JGL
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1); // NOTE: This MUST be called for text rendering to work properly!!!

    Load();

    return true;
}
